<?php
/************************************************************************
 * This file is part of EspoCRM.
 *
 * EspoCRM - Open Source CRM application.
 * Copyright (C) 2014  Yuri Kuznetsov, Taras Machyshyn, Oleksiy Avramenko
 * Website: http://www.espocrm.com
 *
 * EspoCRM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EspoCRM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EspoCRM. If not, see http://www.gnu.org/licenses/.
 ************************************************************************/

class AfterUpgrade
{
    public function run($container)
    {
        $config = $container->get('config');

        $config->set('lastViewedCount', 20);
        $config->save();

        $entityManager = $container->get('entityManager');

        $portalList = $entityManager->getRepository('Portal')->where(['isActive' => true])->limit(0, 10)->find();

        $portalIdList = [];
        foreach ($portalList as $portal) {
            $portalIdList[] = $portal->id;
        }

        $kbCount = $entityManager->getRepository('KnowledgeBaseArticle')->leftJoin('portals')->where(array('portals.id' => null))->count();

        if ($kbCount <= 100) {
            $kbList = $entityManager->getRepository('KnowledgeBaseArticle')->leftJoin('portals')->where(array('portals.id' => null))->find();

            foreach ($kbList as $article) {
                $article->set('portalsIds', $portalIdList);
                $entityManager->saveEntity($article);
            }
        }

        $upgradePath = dirname(dirname(__FILE__));
        $fileManager = $container->get('fileManager');
        $fileManager->copy($upgradePath . '/filesToCopyAfter/application', 'application', true);
    }
}
