<?php
/************************************************************************
 * This file is part of EspoCRM.
 *
 * EspoCRM - Open Source CRM application.
 * Copyright (C) 2014  Yuri Kuznetsov, Taras Machyshyn, Oleksiy Avramenko
 * Website: http://www.espocrm.com
 *
 * EspoCRM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EspoCRM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EspoCRM. If not, see http://www.gnu.org/licenses/.
 ************************************************************************/

class BeforeUpgrade
{
    public function run($container)
    {


        $entityManager = $container->get('entityManager');

        $pdo = $entityManager->getPDO();

        $sql = "
            DROP TABLE IF EXISTS `preferences`
        ";
        $pdo->query($sql);

        $sql = "
            CREATE TABLE IF NOT EXISTS `preferences` (
                `id` varchar(24) NOT NULL,
                `data` text,
                PRIMARY KEY (`id`)
            ) ENGINE=MyISAM DEFAULT CHARSET=utf8;
        ";
        $pdo->query($sql);

        $sql = "
            CREATE TABLE IF NOT EXISTS `action_history_record` (
              `id` varchar(24) COLLATE utf8_unicode_ci NOT NULL,
              `deleted` tinyint(1) DEFAULT '0',
              `number` int(11) NOT NULL AUTO_INCREMENT,
              `data` longtext COLLATE utf8_unicode_ci,
              `action` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
              `created_at` datetime DEFAULT NULL,
              `ip_address` varchar(39) COLLATE utf8_unicode_ci DEFAULT NULL,
              `target_id` varchar(24) COLLATE utf8_unicode_ci DEFAULT NULL,
              `target_type` varchar(100) COLLATE utf8_unicode_ci DEFAULT NULL,
              `user_id` varchar(24) COLLATE utf8_unicode_ci DEFAULT NULL,
              `auth_token_id` varchar(24) COLLATE utf8_unicode_ci DEFAULT NULL,
              PRIMARY KEY (`id`),
              UNIQUE KEY `number` (`number`),
              UNIQUE KEY `UNIQ_5C817D7F96901F54` (`number`),
              KEY `IDX_5C817D7FA76ED395` (`user_id`),
              KEY `IDX_5C817D7F6524603F` (`auth_token_id`),
              KEY `target` (`target_type`,`target_id`)
            ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci ;
        ";
        $pdo->query($sql);

        $userList = $entityManager->getRepository('User')->find();
        foreach ($userList as $user) {
            if (!file_exists('data/preferences/' . $user->id . '.json')) continue;

            $contents = file_get_contents('data/preferences/' . $user->id . '.json');

            $data = \Espo\Core\Utils\Json::decode($contents);
            $dataString = \Espo\Core\Utils\Json::encode($data, \JSON_PRETTY_PRINT);

            $sql = "INSERT INTO `preferences` (`id`, `data`) VALUES (".$pdo->quote($user->id).", ".$pdo->quote($dataString).")";
            $pdo->query($sql);

            unlink('data/preferences/' . $user->id . '.json');
        }
    }
}
